unit frmMain;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Messages, Forms, Controls, Dialogs, ExtCtrls, StdCtrls, LMessages,
  uCEFTypes, uCEFInterfaces, uCEFWorkScheduler, uCEFBrowserWindow, uCEFChromium;

type
  TMainForm = class(TForm)
    bwBrowser: TBrowserWindow;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure btnGOClick(Sender: TObject);
    procedure bwBrowserBrowserClosed(Sender: TObject);
    procedure bwBrowserBrowserCreated(Sender: TObject);
  protected
    {$IFDEF WINDOWS}
    procedure WMEnterMenuLoop(var aMessage: TMessage); message WM_ENTERMENULOOP;
    procedure WMExitMenuLoop(var aMessage: TMessage); message WM_EXITMENULOOP;
    {$ENDIF}
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

uses
  CEFControl, uCEFMiscFunctions;

{ TMainForm }

procedure TMainForm.btnGOClick(Sender: TObject);
begin

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  CefRegisterSchemeHandlerFactory('local','',TLocalResourceHandler);
  bwBrowser.LoadURL('local://files/index.html');
end;

procedure TMainForm.bwBrowserBrowserCreated(Sender: TObject);
begin
  Caption := 'Browser ready';
end;

{$IFDEF WINDOWS}
procedure TMainForm.WMEnterMenuLoop(var aMessage: TMessage);
begin
  inherited;
  if (aMessage.wParam = 0) and (GlobalCEFApp <> nil) then
    GlobalCEFApp.OsmodalLoop := True;
end;

procedure TMainForm.WMExitMenuLoop(var aMessage: TMessage);
begin
  inherited;
  if (aMessage.wParam = 0) and (GlobalCEFApp <> nil) then
    GlobalCEFApp.OsmodalLoop := False;
end;
{$ENDIF}

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  With bwBrowser do
    begin
    CloseBrowser(True);
    CanClose:=IsClosed;
    end;
end;

procedure TMainForm.bwBrowserBrowserClosed(Sender: TObject);
begin
  Close;
end;


initialization
  InitCEF;

finalization
  StopCEF;
end.

